#define INCL_DOSERRORS
#define INCL_DOSMISC
#define INCL_DOSMODULEMGR
#define INCL_DOSRESOURCES
#define INCL_DOSSESMGR
#define INCL_GPI
#define INCL_WIN
#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "atshlres.h"

// ----------------------------------------------------------------------------
// CONSTANTS

#define RESOURCES               "atshlres.dll"
#define PROFILE                 "ATSHELL.INI"
#define HELP_FILE               "atshell.hlp"

#define PRF_DEFAULT_PROGRAM     "DefaultProgram"
#define PRF_STARTUP_PROGRAM     "StartupProgram"
#define PRF_KEY_PROGRAM         "Executable"
#define PRF_KEY_PARAMS          "Parameters"
#define PRF_KEY_DIR             "Directory"
#define PRF_KEY_ENV             "Environment"

#define US_STRING_RES_LIMIT     255   // max. length of a string resource
#define US_DEF_FILESPEC_LIMIT   260   // filespec limit fallback if QSV_MAX_PATH can't be resolved
#define US_PARAMETERS_LIMIT     255   // max. length of a program parameters string
#define US_ENVIRONMENT_LIMIT    255   // max. length of a single environment variable
#define US_PROFILE_LIMIT        260   // max. filespec of the INI file


// ----------------------------------------------------------------------------
// MACROS

#define ErrorPopup( text ) \
    WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, text, "Error", 0, MB_OK | MB_ERROR )


// ----------------------------------------------------------------------------
// TYPEDEFS

typedef struct _Global_Data {
    HAB     hab;                    // anchor-block handle
    HMQ     hmq;                    // main message queue
    HMODULE hResources;             // handle to resource dll
    HINI    hIni;                   // handle to INI file
    BOOL    fRunSilent,             // should default program run silently (no GUI)?
            fRunSecure;             // run securely (no config or prompt buttons)?
    PSZ     pszProgram,             // default program filespec
            pszParams,              // default program parameters
            pszDir,                 // default program startup directory
            pszEnv,                 // default program environment variables
            pszSProgram,            // startup program filespec
            pszSParams,             // startup program parameters
            pszSDir,                // startup program startup directory
            pszSEnv;                // startup program environment variables
} ATSHGLOBAL, *PATSHGLOBAL;

typedef struct _AppConfig_Data {
    HAB     hab;
    HMODULE hResources;
    BOOL    fChanged;
    PSZ     pszProgram,
            pszParams,
            pszDir,
            pszEnv;
    ULONG   ulPathLimit;
} ATSHAPPCONFIG, *PATSHAPPCONFIG;


// ----------------------------------------------------------------------------
// FUNCTIONS

MRESULT EXPENTRY ClientWndProc( HWND, ULONG, MPARAM, MPARAM );
PSZ              LocateProfile( void );
void             LoadProfileSetting( PSZ *pszData, HINI hIni, PSZ pszApp, PSZ pszKey );
void             CentreWindow( HWND hwnd );
void             LaunchPrompt( HWND hwnd );
void             LaunchProgram( HWND hwnd, PSZ pszProgram, PSZ pszParams, PSZ pszDir, PSZ pszEnv, BOOL fHide );
void             DlgConfigure( HWND hwnd, USHORT usProgram );
MRESULT EXPENTRY AppCfgDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );
void             BrowseProgram( HWND hwnd );
MRESULT EXPENTRY AboutDlgProc( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

